static const char *RcsId     = "$Header: $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "";
//+=============================================================================
//
// file :        Standa8SMC3Class.cpp
//
// description : C++ source for the Standa8SMC3Class. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the Standa8SMC3 once per process.
//
// project :     TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.3 $
//
// $Log: Standa8SMC3Class.cpp,v $
// Revision 1.3  2017-03-10 13:19:04  graziano
// tango 9
//
// Revision 1.2  2015-09-08 10:27:00  graziano
// added configurable switch polarity
//
// Revision 1.1  2014-09-22 13:21:58  graziano
// first commit
//
// Revision 1.8  2013-08-23 08:58:58  graziano
// Device_4Impl
//
// Revision 1.7  2009-09-23 15:11:26  graziano
// added attribute Position_home
//
// Revision 1.6  2009/09/23 14:46:29  graziano
// bug fixing
//
// Revision 1.5  2009/08/04 08:40:34  graziano
// fixed attribute properties
//
// Revision 1.4  2009/08/03 12:07:53  graziano
// fixed attribute properties
//
// Revision 1.3  2009/08/03 10:20:51  graziano
// added attribute properties
//
// Revision 1.2  2009/04/02 13:36:40  graziano
// added command find_edge
//
// Revision 1.1  2008/11/19 10:39:26  graziano
// first version
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <Standa8SMC3.h>
#include <Standa8SMC3Class.h>


//+----------------------------------------------------------------------------
/**
 *	Create Standa8SMC3Class singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Standa8SMC3_class(const char *name) {
		return Standa8SMC3_ns::Standa8SMC3Class::init(name);
	}
}


namespace Standa8SMC3_ns
{
//+----------------------------------------------------------------------------
//
// method : 		FindEdgeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *FindEdgeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "FindEdgeClass::execute(): arrived" << endl;

	Tango::DevLong	argin;
	extract(in_any, argin);

	((static_cast<Standa8SMC3 *>(device))->find_edge(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GoToPositionClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GoToPositionClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GoToPositionClass::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<Standa8SMC3 *>(device))->go_to_position(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SetHomeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetHomeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetHomeClass::execute(): arrived" << endl;

	((static_cast<Standa8SMC3 *>(device))->set_home());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GoHomeClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GoHomeClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GoHomeClass::execute(): arrived" << endl;

	((static_cast<Standa8SMC3 *>(device))->go_home());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		BackwardCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *BackwardCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "BackwardCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<Standa8SMC3 *>(device))->backward(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ForwardCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ForwardCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ForwardCmd::execute(): arrived" << endl;

	Tango::DevDouble	argin;
	extract(in_any, argin);

	((static_cast<Standa8SMC3 *>(device))->forward(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorSTANDBYClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorSTANDBYClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorSTANDBYClass::execute(): arrived" << endl;

	((static_cast<Standa8SMC3 *>(device))->motor_standby());
	return new CORBA::Any();
}



//+----------------------------------------------------------------------------
//
// method : 		StopClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StopClass::execute(): arrived" << endl;

	((static_cast<Standa8SMC3 *>(device))->stop());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorOFFCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorOFFCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorOFFCmd::execute(): arrived" << endl;

	((static_cast<Standa8SMC3 *>(device))->motor_off());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		MotorONClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *MotorONClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "MotorONClass::execute(): arrived" << endl;

	((static_cast<Standa8SMC3 *>(device))->motor_on());
	return new CORBA::Any();
}



//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
Standa8SMC3Class *Standa8SMC3Class::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::Standa8SMC3Class(string &s)
// 
// description : 	constructor for the Standa8SMC3Class
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
Standa8SMC3Class::Standa8SMC3Class(string &s):DeviceClass(s)
{

	cout2 << "Entering Standa8SMC3Class constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving Standa8SMC3Class constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::~Standa8SMC3Class()
// 
// description : 	destructor for the Standa8SMC3Class
//
//-----------------------------------------------------------------------------
Standa8SMC3Class::~Standa8SMC3Class()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
Standa8SMC3Class *Standa8SMC3Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Standa8SMC3Class(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

Standa8SMC3Class *Standa8SMC3Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void Standa8SMC3Class::command_factory()
{
	command_list.push_back(new ForwardCmd("Forward",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"relative movement in user units",
		"",
		Tango::OPERATOR));
	command_list.push_back(new BackwardCmd("Backward",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"relative movement in user units",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StopClass("Stop",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorOFFCmd("MotorOFF",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorONClass("MotorON",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new MotorSTANDBYClass("MotorSTANDBY",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GoHomeClass("GoHome",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SetHomeClass("SetHome",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GoToPositionClass("GoToPosition",
		Tango::DEV_DOUBLE, Tango::DEV_VOID,
		"absolute position in user units",
		"",
		Tango::OPERATOR));
	command_list.push_back(new FindEdgeClass("FindEdge",
		Tango::DEV_LONG, Tango::DEV_VOID,
		"0=find left limit switch 1=find right limit switch",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum Standa8SMC3Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum Standa8SMC3Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum Standa8SMC3Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void Standa8SMC3Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new Standa8SMC3(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: Standa8SMC3Class::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void Standa8SMC3Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Stat
	StatAttrib	*stat = new StatAttrib();
	Tango::UserDefaultAttrProp	stat_prop;
	stat_prop.set_description("0=standby\n1=moving\n2=resetting to left\n3=resetting to right");
	stat->set_default_properties(stat_prop);
	att_list.push_back(stat);

	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib();
	Tango::UserDefaultAttrProp	position_prop;
	position_prop.set_unit("degree");
	position_prop.set_standard_unit("1.0");
	position_prop.set_display_unit("degree");
	position_prop.set_format("%8.5f");
	position_prop.set_max_value("620");
	position_prop.set_min_value("-620");
	position->set_default_properties(position_prop);
	att_list.push_back(position);

	//	Attribute : Acceleration
	AccelerationAttrib	*acceleration = new AccelerationAttrib();
	Tango::UserDefaultAttrProp	acceleration_prop;
	acceleration_prop.set_format("%3d");
	acceleration_prop.set_max_value("255");
	acceleration_prop.set_min_value("0");
	acceleration_prop.set_description("255: min acceleration, 1=max acceleration");
	acceleration->set_default_properties(acceleration_prop);
	att_list.push_back(acceleration);

	//	Attribute : Accuracy
	AccuracyAttrib	*accuracy = new AccuracyAttrib();
	Tango::UserDefaultAttrProp	accuracy_prop;
	accuracy_prop.set_format("%1d");
	accuracy_prop.set_max_value("4");
	accuracy_prop.set_min_value("0");
	accuracy_prop.set_description("argin=\n1 -> full step\n2 -> half step\n3 -> 1/4 step\n4 -> 1/8 step");
	accuracy->set_default_properties(accuracy_prop);
	att_list.push_back(accuracy);

	//	Attribute : Position_home
	Position_homeAttrib	*position_home = new Position_homeAttrib();
	Tango::UserDefaultAttrProp	position_home_prop;
	position_home_prop.set_unit("degree");
	position_home_prop.set_standard_unit("1.0");
	position_home_prop.set_display_unit("degree");
	position_home_prop.set_format("%8.5f");
	position_home_prop.set_max_value("620");
	position_home_prop.set_min_value("-620");
	position_home_prop.set_description("Default home position");
	position_home->set_default_properties(position_home_prop);
	att_list.push_back(position_home);

	//	Attribute : Speed
	SpeedAttrib	*speed = new SpeedAttrib();
	Tango::UserDefaultAttrProp	speed_prop;
	speed_prop.set_unit("Tiks Hz");
	speed_prop.set_standard_unit("1.0");
	speed_prop.set_display_unit("Tiks Hz");
	speed_prop.set_format("4d");
	speed_prop.set_max_value("9999");
	speed_prop.set_min_value("0");
	speed_prop.set_description("double[0]: min speed\ndouble[1]: max speed");
	speed->set_default_properties(speed_prop);
	att_list.push_back(speed);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void Standa8SMC3Class::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	Standa8SMC3Class::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void Standa8SMC3Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "AxisNumber";
	prop_desc = "Number of the Axis on the motion controller";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisForwardLimit";
	prop_desc = "This is the Motion controller software forward limit\nStops any movement passing that limit";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "AxisBackwardLimit";
	prop_desc = "Motion controller software backward limit.";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Serialdevice";
	prop_desc = "the serial device used for communications with Standa Stepper Motor controller";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Serial_timeout";
	prop_desc = "Serial port timeout in ms";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Wr_sleep";
	prop_desc = "Sleep time in ms between serial write of a command and serial read of the response";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Th_sleep";
	prop_desc = "Sleep time in ms between threads";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PositionRatio";
	prop_desc = "the ratio between hardware units and user units";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DefaultMaxSpeed";
	prop_desc = "Max speed (steps/s): 377 min value, 9091 max value";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DefaultMinSpeed";
	prop_desc = "Default Min speed: 377 min value, 9091 max value";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DefaultAcceleration";
	prop_desc = "Default acceleration: 255 min value, 01 max value";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MaxAllowedSpeed";
	prop_desc = "Max allowed speed (steps/s): 9091 highest value, 377 lowest value";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Current_position";
	prop_desc = "current position of the rotation stage";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Limit_switch_polarity";
	prop_desc = "Limit Switch Polarity Active Low (0) or Active High (1)";
	prop_def  = "1";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "Socket";
	prop_desc = "true -> serial through moxa";
	prop_def  = "false";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		Standa8SMC3Class::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void Standa8SMC3Class::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Standa 8SMC3-RS232 Stepper Motor Controller");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Device Server for the Standa 8SMC3-RS232 Stepper Motor Controller");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
